/* Copyright 2013 Forex Capital Markets LLC

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use these files except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
#include "stdafx.h"
#include "LocalFormat.h"

LocalFormat::LocalFormat()
{
    mListSeparator = "";
    mDecimalSeparator = "";
}

const char *LocalFormat::getListSeparator()
{
    if (mListSeparator.length() == 0)
    {
        char buff[32];
        int rc;
        rc = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SLIST, buff, 32);
        buff[rc] = 0;
        mListSeparator = buff;
    }
    return mListSeparator.c_str();
}

const char *LocalFormat::getDecimalSeparator()
{
    if (mDecimalSeparator.length() == 0)
    {
        char buff[32];
        int rc;
        rc = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SDECIMAL, buff, 32);
        buff[rc] = 0;
        mDecimalSeparator = buff;
    }
    return mDecimalSeparator.c_str();
}

std::string LocalFormat::formatDouble(double value, int precision)
{
    char format[16];
    char buffer[64];

    sprintf_s(format, 16, "%%.%if", precision);
    sprintf_s(buffer, 64, format, value);
    char *point = strchr(buffer, '.');
    if (point != 0)
        *point = getDecimalSeparator()[0];

    return std::string(buffer);
}

std::string LocalFormat::formatDate(double value)
{
    SYSTEMTIME st;
    memset(&st, 0, sizeof(st));
    VariantTimeToSystemTime(value, &st);
    char buffer[64];
    std::string res = "";

    int rc = GetDateFormat(LOCALE_USER_DEFAULT, DATE_SHORTDATE, &st, 0, buffer, 64);
    buffer[rc] = 0;
    res += buffer;
    res += " ";
    rc = GetTimeFormat(LOCALE_USER_DEFAULT, 0, &st, 0, buffer, 64);
    buffer[rc] = 0;
    res += buffer;

    return res;
}
