/* Copyright 2013 Forex Capital Markets LLC

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use these files except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
#pragma once

/** Class to work with login parameters. */
class LoginParams
{
 public:
    /** Class with static methods that return error messages. */
    class Strings
    {
    public:
        static const char *loginNotSpecified;
        static const char *passwordNotSpecified;
        static const char *urlNotSpecified;
        static const char *connectionNotSpecified;
    };
 public:
    LoginParams(int, char **);
    ~LoginParams(void);

    const char *getLogin();
    const char *getPassword();
    const char *getURL();
    const char *getConnection();
    const char *getSessionID();
    const char *getPin();

 private:
    const char *getArgument(int, char **, const char *);

    std::string mLogin;
    std::string mPassword;
    std::string mURL;
    std::string mConnection;
    std::string mSessionID;
    std::string mPin;
};

